package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.BGYPSQMX;
import com.sa.ibiz.demo.demo.service.BGYPSQMXService;
import com.sa.ibiz.demo.demo.service.dto.BGYPSQMXSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/bgypsqmx")
public class BGYPSQMXResource
{
	@Autowired
	private BGYPSQMXService service;


	@PostMapping(value = "/create")
	public ResponseEntity<BGYPSQMX> create(@Validated @RequestBody BGYPSQMX data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请明细[create]操作发生错误","BGYPSQMX",data.getBgypsqmxid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<BGYPSQMX> get(@Validated @PathVariable String id){
		BGYPSQMX data=new BGYPSQMX();
		data.setBgypsqmxid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("办公用品申请明细[get]操作发生错误","BGYPSQMX",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<BGYPSQMX> remove(@Validated @RequestBody BGYPSQMX data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请明细[remove]操作发生错误","BGYPSQMX",data.getBgypsqmxid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<BGYPSQMX> update(@Validated @RequestBody BGYPSQMX data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请明细[update]操作发生错误","BGYPSQMX",data.getBgypsqmxid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<BGYPSQMX> getDraft(@Validated @RequestBody BGYPSQMX data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请明细[getDraft]操作发生错误","BGYPSQMX","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<BGYPSQMX> checkKey(@Validated @RequestBody BGYPSQMX data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("办公用品申请明细[checkKey]操作发生错误","BGYPSQMX",data.getBgypsqmxid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<BGYPSQMX>> searchDefaultPage(@Validated @RequestBody BGYPSQMXSearchFilter filter){
		Page<BGYPSQMX> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<BGYPSQMX>> listDefault(@Validated @RequestBody BGYPSQMXSearchFilter filter){
		List<BGYPSQMX> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
